package cn.iocoder.yudao.module.iot.service.kanban;

import cn.iocoder.yudao.framework.common.pojo.PageResult;
import cn.iocoder.yudao.framework.common.util.object.BeanUtils;
import cn.iocoder.yudao.module.iot.controller.admin.kanban.vo.KanbanPageReqVO;
import cn.iocoder.yudao.module.iot.controller.admin.kanban.vo.KanbanSaveReqVO;
import cn.iocoder.yudao.module.iot.dal.dataobject.kanban.KanbanDO;
import cn.iocoder.yudao.module.iot.dal.mysql.kanban.KanbanMapper;
import org.springframework.stereotype.Service;
import org.springframework.validation.annotation.Validated;

import javax.annotation.Resource;

import static cn.iocoder.yudao.framework.common.exception.util.ServiceExceptionUtil.exception;
import static cn.iocoder.yudao.module.iot.enums.ErrorCodeConstants.KANBAN_NOT_EXISTS;

/**
 * 物联看板 Service 实现类
 *
 * @author 内蒙必硕
 */
@Service
@Validated
public class KanbanServiceImpl implements KanbanService {

    @Resource
    private KanbanMapper kanbanMapper;

    @Override
    public Long createKanban(KanbanSaveReqVO createReqVO) {
        // 插入
        KanbanDO kanban = BeanUtils.toBean(createReqVO, KanbanDO.class);
        kanbanMapper.insert(kanban);
        // 返回
        return kanban.getId();
    }

    @Override
    public void updateKanban(KanbanSaveReqVO updateReqVO) {
        // 校验存在
        validateKanbanExists(updateReqVO.getId());
        // 更新
        KanbanDO updateObj = BeanUtils.toBean(updateReqVO, KanbanDO.class);
        kanbanMapper.updateById(updateObj);
    }

    @Override
    public void deleteKanban(Long id) {
        // 校验存在
        validateKanbanExists(id);
        // 删除
        kanbanMapper.deleteById(id);
    }

    private void validateKanbanExists(Long id) {
        if (kanbanMapper.selectById(id) == null) {
            throw exception(KANBAN_NOT_EXISTS);
        }
    }

    @Override
    public KanbanDO getKanban(Long id) {
        return kanbanMapper.selectById(id);
    }

    @Override
    public PageResult<KanbanDO> getKanbanPage(KanbanPageReqVO pageReqVO) {
        return kanbanMapper.selectPage(pageReqVO);
    }

}